<?php

namespace Drupal\checkbox_radio_buttons_multi_columns\Plugin\Field\FieldWidget;

use Drupal\Core\Field\Plugin\Field\FieldWidget\OptionsButtonsWidget;
use Drupal\Core\Form\FormStateInterface;
use Drupal\Core\Field\FieldItemListInterface;

/**
 * Plugin implementation of the 'multi_column_options_buttons' widget.
 *
 * @FieldWidget(
 *   id = "multi_column_options_buttons",
 *   label = @Translation("Check boxes/radio buttons (multi-columns)"),
 *   field_types = {
 *     "boolean",
 *     "entity_reference",
 *     "list_integer",
 *     "list_float",
 *     "list_string",
 *   },
 *   multiple_values = TRUE
 * )
 */

class MultiColumnOptionsButtonsWidget extends OptionsButtonsWidget {

  /**
   * {@inheritdoc}
   */
  public static function defaultSettings() {
    return [
      'columns' => '',
    ] + parent::defaultSettings();
  }

  /**
   * {@inheritdoc}
   */
  public function settingsForm(array $form, FormStateInterface $form_state) {
    $element['columns'] = [
      '#type' => 'number',
      '#title' => $this->t('Columns'),
      '#description' => $this->t('Amount of columns the checkboxes should be divided on.'),
      '#default_value' => $this->getSetting('columns'),
      '#required' => TRUE,
    ];

    return $element;
  }

}
